using System;
using PokemonStats;
using Inventory;
namespace PokemonRot
{
    class PokemonEncounter
    {
        string wildPokemonName;
        int wildPokemonHP;
        int baseWildPokemonHP;
        float baseChanceToCatch;
        int wildPokemonDMG;
        int pokemonDMG;
        string pokemonName;
        int pokemonHP;
        int numberOfPokeballs;
        bool wildPokemonIsCatch = false;

        
        public static void Main()
        {
            PokemonStatistic pokemon = new PokemonStatistic();
            Inventory inventory= new Inventory();
            wildPokemonHP= pokemon.HP;
            baseWildPokemonHP= pokemon.HP;
            wildPokemonName = pokemon.name;
            baseChanceToCatch = pokemon.chanceOfCatch;
            wildPokemonDMG = pokemon.DMG;
            numberOfPokeballs = inventory.Pokeballs;
        }
        static float NextFloat(float min, float max)
        {
            System.Random random = new System.Random();
            double val = (random.NextDouble() * (max - min) + min);
            return (float)val;
        }
        private void TryToCatch()
        {
            numberOfPokeballs-=1;
            if (baseChanceToCatch <= NextFloat(0,100))
            {
                wildPokemonIsCatch=true;
                Endscene();
            }
        }
        private void Attack()
        {
            wildPokemonHP -= pokemonDMG*NextFloat(0.1,1);
            if(wildPokemonHP<=0)
            {
                Endscene();
            }
        }
        private void Run()
        {
            Endscene();
        }
        private void PokemonTurn()
        {
            bool willAttack=true;
            if(wildPokemonHP>= 0.5*baseWildPokemonHP && wildPokemonHP< 0.75*baseWildPokemonHP)
            {
                if (90 <= NextFloat(0,100))
                {
                    willAttack=false;
                }
            }
            else if(wildPokemonHP>= 0.25*baseWildPokemonHP)
            {
                if (75 <= NextFloat(0,100))
                {
                    willAttack=false;
                }
            }
            else
            {
                if (50 <= NextFloat(0,100))
                {
                    willAttack=false;
                }
            }
            if(willAttack)
            {
                Attack();
            }
            else
            {
                PokemonTryToRun();
            }
        }
        private void PokemonTryToRun()
        {
            if (50 <= NextFloat(0,100))
            {
                Endscene();
            }

        }
        /*private void ChangePokemon()
        {
            // TODO: výměna pokémona z batohu
        }
        private void PokemonAttack()
        {
            pokemonHP-=wildPokemonDMG*NextFloat(0.1,1);
        }
        void Endscene()
        {
            // TODO:uložení a ukončení scény
        }*/
    }
}